#ifndef CERERINGBUFFER_H_18A7F155
#define CERERINGBUFFER_H_18A7F155
/** \file CereRingBuffer.h
    \brief Template specializations for ring buffers in use with CereConn,
         tuned for Blackrock NSPs

**/

#include <array>
#include <cstdint>
#include <utility>
#include <vector>

#include "CereConnBaseTypes.h"
#include "CereConstants.h"

#include "rb/RingBuffer.h"
#include "rb/SampleGroupRingBuffer.h"
#include "rb/SampleGroupList.h"
#include "rb/CommentRingBuffer.h"
#include "rb/SpikeRingBuffer.h"
#include "rb/DigInEvRingBuffer.h"

namespace cc
{

// template<typename TData, typename TTimestamp, size_t MaxChannels, size_t Size>
using SampleGroupRingBuffer = SampleGroupRingBufferT<Datum_t, Timestamp_t, constants::MaxAnalogChannels, constants::ContSamples>;

using SampleGroupRingBufferCollection = SampleGroupRingBufferCollectionT<Datum_t, Timestamp_t, constants::MaxAnalogChannels, constants::ContSamples, constants::NSampleGroups>;

using SampleGroupChunk = SampleGroupChunkT<Datum_t, Timestamp_t, constants::MaxAnalogChannels, constants::ContSamples>;
using SampleGroupList = SampleGroupListT<Datum_t, Timestamp_t, constants::MaxAnalogChannels, constants::ContSamples, constants::NSampleGroups>;

using Comment = CommentT<Timestamp_t, constants::CommentLength>;
using CommentList = CommentListT<Timestamp_t, constants::CommentLength>;
using CommentRingBuffer = CommentRingBufferT<Timestamp_t, constants::CommentLength, constants::CommentsCached>;

using DigInEv = DigInEvT<Timestamp_t>;
using DigInEvList = DigInEvListT<Timestamp_t>;
using DigInEvRingBuffer = DigInEvRingBufferT<Timestamp_t, constants::DigInEvCached>;

using Spike = SpikeT<Datum_t, Timestamp_t, Channel_t, Unit_t, constants::EventSnippetSamples>;
using SpikeRingBuffer = SpikeRingBufferT<Datum_t, Timestamp_t, Channel_t, Unit_t, constants::EventSnippetSamples, constants::SpikesCached>;

}
#endif /* end of include guard: CERERINGBUFFER_H_18A7F155 */
