#ifndef SAMPLEGROUPLIST_H_9B672AB5
#define SAMPLEGROUPLIST_H_9B672AB5


#include <map>
#include <set>
#include <vector>

#include "CereConnBaseTypes.h"

namespace cc
{

template<typename TData, typename TTimestamp, size_t MaxChannels, size_t Size>
struct SampleGroupChunkT
{
    TTimestamp                      last_timestamp;
    std::vector<TData>              buffer;
    ChannelNumList_t                channel_ids;
    size_t                          sample_period;
    bool                            channel_ids_changed;
    size_t                          overflow_count;
    SampleGroupChunkT()
        : last_timestamp(0)
        , sample_period(0)
        , channel_ids_changed(false)
        , overflow_count(0)
    {
        buffer.reserve(Size * MaxChannels);
        channel_ids.reserve(MaxChannels);
    }
};


template<typename TData, typename TTimestamp, size_t MaxChannels, size_t Size, size_t NSampleGroups>
struct SampleGroupListT
{
    std::vector<SampleGroupChunkT<TData, TTimestamp, MaxChannels, Size>> sgc;
    TTimestamp timestamp;
    
    SampleGroupListT(): sgc(NSampleGroups), timestamp(0) {};

};

}

#endif /* end of include guard: SAMPLEGROUPLIST_H_9B672AB5 */
