# armadillo bindings lifted from https://github.com/andrewcron/cy_armadillo
from libcpp cimport bool
cimport numpy as np
cdef extern from "armadillo" namespace "arma" nogil:
    cdef cppclass vec:
       cppclass iterator:
           double& operator*()
           iterator operator++()
           iterator operator--()
           iterator operator+(size_t)
           iterator operator-(size_t)
           bint operator==(iterator)
           bint operator!=(iterator)
           bint operator<(iterator)
           bint operator>(iterator)
           bint operator<=(iterator)
           bint operator>=(iterator)
       cppclass reverse_iterator:
           double& operator*()
           iterator operator++()
           iterator operator--()
           iterator operator+(size_t)
           iterator operator-(size_t)
           bint operator==(reverse_iterator)
           bint operator!=(reverse_iterator)
           bint operator<(reverse_iterator)
           bint operator>(reverse_iterator)
           bint operator<=(reverse_iterator)
           bint operator>=(reverse_iterator)
       vec(double * aux_mem, int number_of_elements, bool copy_aux_mem, bool strict) nogil
       vec(double * aux_mem, int number_of_elements) nogil
       vec(int) nogil
       vec() nogil
       # attributes
       int n_elem
       # opperators
       double& operator[](int)
       double& at(int)
       vec operator%(vec)
       vec operator+(vec)
       vec operator/(vec)
       vec operator*(mat)
       vec operator*(double)
       vec operator-(double)
       vec operator+(double)
       vec operator/(double)
       iterator begin()
       iterator end()
       reverse_iterator rbegin()
       reverse_iterator rend()
       # functions
       double * memptr()
       void raw_print(char*) nogil
       void raw_print() nogil

cdef vec numpy_to_vec_d(np.ndarray[np.double_t, ndim=1] x)
cdef np.ndarray[np.double_t, ndim=1] vec_to_numpy(const vec & X, np.ndarray[np.double_t, ndim=1] D)
