#!/usr/bin/env python3
## @package test_01
# Continuous Test 02
#
# @author Jonas Zimmermann
#
# This test will open a connection to an NSP, and it will test for buffer overflow

import time
import cere_conn as cc

# get CereConn object
ck = cc.CereConn()
ck.send_open()

# Wait until connection is established
t = time.time()
while ck.get_state() != cc.ccS_Idle:
    time.sleep(0.005)
print("It took {:5.3f}s to open CereConn\n".format(time.time() - t))

# start recording
ck.send_record()

t = time.time()
while ck.get_state() != cc.ccS_Recording:
    time.sleep(0.05)
print("It took {:5.3f}s to start CereConn recording\n".format(time.time() - t))

# at least with NPlayServer, we need to wait for things to settle
time.sleep(.5)

gids = [1, 2, 3, 4, 5, 6]
for gid in gids:
    ck.set_sample_group_state(gid, True)


# keep stats...
lasttime = time.time()
cd = ck.get_cont_data()
time.sleep(1)
ck.print_buffer_state()
time.sleep(1)
ck.print_buffer_state()
time.sleep(1)
print("Buffer should start to overrun now for sample groups 5 and 6 ...")
ck.print_buffer_state()
time.sleep(1)
ck.print_buffer_state()
time.sleep(1)
ck.print_buffer_state()

ck.send_close()

while ck.get_state() != cc.ccS_Closed:
    time.sleep(0.05)
