#!/usr/bin/env python3
## @package test_01
# Digital Input / Serial Event Test 01
#
# @author Jonas Zimmermann
#
# This test will open a connection to an NSP, and it will retrieve digital events.

import time

import cere_conn as cc

ck = cc.CereConn()

ck.send_open()

t = time.time()
while ck.get_state() != cc.ccS_Idle:
    time.sleep(0.005)
print("It took {:5.3f}s to open CereConn\n".format(time.time() - t))

ck.send_record()

t = time.time()
while ck.get_state() != cc.ccS_Recording:
    time.sleep(0.2)
print("It took {:5.3f}s to start CereConn recording\n".format(time.time() - t))

start_time = time.time()


ck.get_digin_ev_data()

time.sleep(1.0)

out = ck.get_digin_ev_data()
print(out)

ck.send_close()
while ck.get_state() != cc.ccS_Closed:
    time.sleep(0.05)



