#ifdef CC_TESTING_DEBUG
#include "sre/UnitHist.h"


namespace cc
{
namespace sre
{

template <typename T, class Container>
void UnitHist<T, Container>::print_debug() const
{
    printf("V: ");
    for (auto it = m_c.cbegin(); it != m_c.cend(); ++ it)
    {
        if (it == m_c_it)
        {
            printf("[");
        }
        printf("%i", int(*it));
        if (it == m_c_it)
        {
            printf("]");
        }
        printf(" ");
    }
    if (has_spikes())
    {
        printf(" has spikes.");
    }
    else
    {
        printf(" no spikes.");
    }
    printf("\n\t[Forward]: ");
    for (auto it = cbegin(); it != cend(); ++it)
    {
        printf("%d ", int(*it));
    }
    printf("\n\t[Reverse]: ");
    for (auto it = crbegin(); it != crend(); ++it)
    {
        printf("%d ", int(*it));
    }
    printf("\n");
}

// template < class Container>
template<>
void UnitHist<unsigned int>::print_debug() const
{
    printf("V: ");
    for (auto it = m_c.cbegin(); it != m_c.cend(); ++ it)
    {
        if (it == m_c_it)
        {
            printf("[");
        }
        printf("%u", *it);
        if (it == m_c_it)
        {
            printf("]");
        }
        printf(" ");
    }
    if (has_spikes())
    {
        printf(" has spikes.");
    }
    else
    {
        printf(" no spikes.");
    }
    printf("\n\t[Forward]: ");
    for (auto it = cbegin(); it != cend(); ++it)
    {
        printf("%u ", *it);
    }
    printf("\n\t[Reverse]: ");
    for (auto it = crbegin(); it != crend(); ++it)
    {
        printf("%u ", *it);
    }
    printf("\n");
}



} // namespace sre
} // namespace cc
#endif

