'''
description: online decoder
author: Ioannis Vlachos
date:   20.07.18

Copyright (c) 2018 Ioannis Vlachos.
All rights reserved.'''


# CLASSIFIER
with open('classifier.pkl', 'rb') as fid:
    clf = pickle.load(fid)


for trial_ii, trial_nr in enumerate(range(len(data_total['neural']['raw']))[pars.trials.n_norm:pars.trials.n_norm + pars.trials.n_tot]):
    data_trial = data_total['neural']['raw'][trial_nr][1][2]
    arr0 = buffer_to_array(data_trial)
    arr = signal.resample(arr0, arr0.shape[1] // pars.sampling.smpl_fct, axis=1)          # downsample
    fs = pars.sampling.fs // pars.sampling.smpl_fct

    av = np.mean(arr, axis=0)                                               # car: remove common average
    arr2 = arr - av
    arr2_lp, taps = methods.low_pass_filter(arr2, pars)

    f3, t3, spectrogram = signal.stft(arr2_lp, fs=fs, window='hamming', nperseg=256, noverlap=203)

    # NORMALIZE
    arr_norm2 = arr_norm.reshape(arr_norm.shape + (1,)).repeat(spectrogram.shape[2], axis=2)
    spectrogram = np.abs(spectrogram) / arr_norm2

    features_trial = spectrogram[features[:, 0], features[:, 1], :]

    Xtot = features_trial.reshape(1, -1)
    
    pred = clf.predict(Xtot)
    print("\nprediction: ", pred)
