''' testing efficient sorting methods for freq bands'''


import matplotlib.pyplot as plt
import numpy as np

features = np.zeros((50, 2), dtype=int)

snr = np.arange(150)
np.random.shuffle(snr)
snr = snr.reshape(50, 3)


num = snr.size
idx0 = np.argpartition(snr.flatten(), range(num))[-num:]
idx1 = np.vstack(np.unravel_index(idx0, snr.shape)).T     # [channel_nr, tbin, freq_comp]
idx2 = idx1[:, [0, 1]].astype(int)
_, ww = np.unique(idx2, axis=0, return_index=True)
ww.sort()
# idx3 = idx2[ww]
idx3 = np.flipud(idx2[ww])

# check if elemens are monotonically decreasing
aa = np.array([snr[nn[0], nn[1]] for nn in idx3])
assert(np.all(aa[1:] <= aa[:-1]))                   
print(aa)

plt.plot(aa,'o')

features[:5, :] = idx3[idx3[:, 1] == 0, :][:5]
features[5:10, :] = idx3[idx3[:, 1] == 1, :][:5]
features[10:15, :] = idx3[idx3[:, 1] == 2, :][:5]

idx = idx3
idx = np.delete(idx, np.where(idx[:, 1] == 0)[0][:5], axis=0)
idx = np.delete(idx, np.where(idx[:, 1] == 1)[0][:5], axis=0)
idx = np.delete(idx, np.where(idx[:, 1] == 2)[0][:5], axis=0)

features[15:50] = idx[:35]


aa = np.array([snr[nn[0], nn[1]] for nn in features])
# assert(np.all(aa[1:] <= aa[:-1]))                   
print(aa)

plt.plot(aa, 'o')

plt.show()
