import time

import matplotlib.pyplot as plt
import numpy as np

x = np.arange(0, 2*np.pi, 0.1)
y = lambda x, i : np.sin(3*x + i/10.)


fig = plt.figure(1)
plt.clf()
ax = plt.gca()
fig.show()

# We need to draw the canvas before we start animating...
fig.canvas.draw()

lines = [ax.plot(x, y(x, 0) + zz)[0] for zz in range(2)]

background = fig.canvas.copy_from_bbox(ax.bbox)

T = 100
tstart = time.time()
for i in range(1, T):
    fig.canvas.restore_region(background)
    for zz in range(2):
        lines[zz].set_ydata(y(x, i) + zz)
        ax.draw_artist(lines[zz])
    fig.canvas.blit(ax.bbox)
    time.sleep(0.0001)

print('FPS:' , T/(time.time()-tstart))
