"""
Configure NSP with 96 channels at 30k

@author: Ali Zaidi
@version: 0.1
@date: 04.10.18
"""

import sys
import time

import cerebus.cbpy as cb


def configure():
    """
    Configures 96 channels at 30k
    """

    # Define channels to be configured
    channels = list(range(1, 97))  # Must be configurable

    # Set channels to 30k
    for channel in channels:
        res = cb.set_channel_config(channel, chaninfo={'smpgroup': 5})
        time.sleep(0.02)


def validat():
    pass

    # ! To be added !


try:
    res = cb.open()
except Exception as e:
    sys.exit("Cerelink cannot connect to the NSP. Exiting")
if res[0] >= 0:
    print("Successfully opened connection to NSP!")
    configure()
    print("Successfully configured 96 channels at 30k. You are now setup!")
    res = cb.close()
