'''
description: speller matrix, can be used in separate process in parallel with colorspeller paradigm
author: Ioannis Vlachos
date:   29.07.19

Copyright (c) 2019 Ioannis Vlachos.
All rights reserved.'''

from aux import log
import multiprocessing as mp
import tkinter as tk


class sp_matrix():
    def __init__(self, master, child_conn):
        width = 24
        width2 = 24
        width3 = 24
        height = 10
        height2 = 2
        height3 = 5
        fsize = 25
        fsize2 = 15
        fsize3 = 15
        bg = '#222222'
        fg = '#888888'
        self.fg2 = '#FFFFFF'
        font = 'Trebuchet'
        # yellow, green, red, blue, white = 'yellow', 'green', 'red', 'blue', 'white'
        yellow, green, red, blue, white = '#efd210', '#14980C', '#DC101D', '#102DEF', 'white'
        # text0 = Text(root, height=2, width=width, font=("Verdana", fsize), fg='yellow', bg='black')
        text1 = tk.Text(master, height=height, width=width, font=(font, fsize), fg=self.fg2, bg=bg)
        text2 = tk.Text(master, height=height2, width=width2, font=(font, fsize2), fg=self.fg2, bg=bg)
        text3 = tk.Text(master, height=height3, width=width3, font=(font, fsize3), fg=self.fg2, bg=bg)


        text1.insert(tk.INSERT, " E  A  D  C  B  F     ^\n\n")
        text1.insert(tk.INSERT, " N  S  R  O  M  P  Q\n\n")
        text1.insert(tk.INSERT, " I  H  L  G  K  J\n\n")
        text1.insert(tk.INSERT, " T  U  W  Z  V  Y  X\n\n")
        text1.insert(tk.INSERT, " <  <<<  _ . ? word end\n\n")
        text2.insert(tk.INSERT, "")
        text3.insert(tk.INSERT,"")

        text1.pack(expand=0, fill=tk.BOTH)
        text2.pack(expand=0, fill=tk.BOTH)
        text3.pack(expand=0, fill=tk.BOTH)
        # adding a tag to a part of text specifying the indices
        text1.tag_add("yellow", "1.0", "1.21")
        text1.tag_add("green", "3.0", "3.23")
        text1.tag_add("red", "5.0", "5.21")
        text1.tag_add("blue", "7.0", "7.23")
        text1.tag_add("white", "9.0", "9.23")
        text1.tag_config("yellow", background=bg, foreground=yellow)
        text1.tag_config("green", background=bg, foreground=green)
        text1.tag_config("red", background=bg, foreground=red)
        text1.tag_config("blue", background=bg, foreground=blue)
        text1.tag_config("white", background=bg, foreground=white)
        
        self.text1 = text1
        self.text2 = text2
        self.text3 = text3

        self.child_conn = child_conn
        self.count = 0
        self.item_old = ''
        self.item_old_idx = 0
        self.update()

        return None



    def update(self):
        tmp = self.child_conn.recv()
        self.item_new = tmp[0]
        current_string = tmp[1]
        probable_words = tmp[2]

        log.warning(f'got: {self.item_new}, {current_string}, {probable_words}')


        # if self.item_new:
            # self.text1.tag_remove("active", f'1.{self.col1}', f'1.{self.col2}')
        if len(self.item_old) > 0 and self.item_old_idx>0:
            self.text1.tag_remove("active", self.item_old_idx)
            self.item_old_idx = 0
        else:
            index = self.text1.search(self.item_old, 1.0)
            if index != '':
                self.text1.tag_remove("active", index)

        if self.item_new == ' ':
            self.item_new = '_'

        if self.item_new == 'gelb':
            self.text1.tag_add("active", 1.0)
            self.item_old_idx = 1.0
            self.text1.tag_config("active", foreground=self.fg2, underline=True)
        elif self.item_new == 'gruen':
            self.text1.tag_add("active", 3.0)
            self.item_old_idx = 3.0
            self.text1.tag_config("active", foreground=self.fg2, underline=True)
        elif self.item_new == 'rot':
            self.text1.tag_add("active", 5.0)
            self.item_old_idx = 5.0
            self.text1.tag_config("active", foreground=self.fg2, underline=True)
        elif self.item_new == 'blau':
            self.text1.tag_add("active", 7.0)
            self.item_old_idx = 7.0
            self.text1.tag_config("active", foreground=self.fg2, underline=True)
        elif self.item_new == 'weiss':
            self.text1.tag_add("active", 9.0)
            self.item_old_idx = 9.0
            self.text1.tag_config("active", foreground=self.fg2, underline=True)
        # elif self.item_new == ' ':      # new word
        #     self.text1.tag_add("active", 9.4)
        #     self.item_old_idx = 9.4
        #     self.text1.tag_config("active", foreground=self.fg2, underline=True)

        else:    
            index = self.text1.search(self.item_new, 1.0)
            if index != '':
                self.text1.tag_add("active", index)
                self.text1.tag_config("active", foreground=self.fg2, underline=True)

        self.text2.delete("1.0", "end")
        self.text2.insert(tk.INSERT, probable_words)

        self.text3.delete("1.0", "end")
        self.text3.insert(tk.INSERT, current_string)

        self.text1.after(100, self.update)
        self.item_old = self.item_new

        return None