#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jul  5 15:52:55 2018

@author: ale
"""

import sys

import munch
import pyaudio

from paradigms import colorSpeller, exploration, question, trainingColorSpeller

# initialize pyAudio
pyaudio.PyAudio()

# Read the paradigms from the yaml file
yamlfile = 'paradigm.yaml'
with open(yamlfile) as stream:
    config = munch.fromYAML(stream)

print('*** Choose Paradigm ***')
print([key for key in config])
paradigm = input('Choose one from above: ')

# Initialize the correct paradigm
print('*** Initialize paradigm ***')
if paradigm == 'color':
    sp = colorSpeller.ColorSpeller()
elif paradigm == 'training_color':
    sp = trainingColorSpeller.TrainingColorSpeller()
elif paradigm == 'exploration':
    sp = exploration.Exploration()
elif paradigm == 'question':
    sp = question.Question()
else:
    print('Paradigm not available')
    sys.exit()

print('Modality: ' + sp.get_mode())

print('*** Start paradigm ***')

finish = False

while not finish:
    print('Current state: ' + sp.get_current_state()[0] + ' - ' + sp.get_current_state()[1])

    # Present the stimulus
    stim = sp.present_stimulus(audio=True)
    
    # Answer using the keyboard
    answer = input(stim + '? ')
    if answer is 'y':
        decision = True
    elif answer is 'q':
        break
    else:
        decision = False
    
    # Process the answer
    finish = sp.process_result(decision)

# Close the paradigm
sp.close()
