'''
description: testing speller with dynamically updated matrix
author: Ioannis Vlachos
date:   29.07.19

Copyright (c) 2019 Ioannis Vlachos.
All rights reserved.'''

import importlib
import logging
import sys
import time
from random import randint

import tkinter as tk
import munch
# import pyaudio
from colorlog import ColoredFormatter

import aux
from aux import log
from paradigms import colorSpeller, exploration, question, trainingColorSpeller, sp_matrix
import multiprocessing as mp
from multiprocessing import Array, Pipe



importlib.reload(trainingColorSpeller)
importlib.reload(colorSpeller)
importlib.reload(aux)



def speller_matrix(child_conn):
    root = tk.Tk()
    sp_matrix.sp_matrix(root, child_conn)
    root.mainloop()

parent_conn, child_conn = Pipe()

matrix = mp.Process(name='matrix', target=speller_matrix, args=(child_conn,))
matrix.daemon = True    
matrix.start()


paradigm_type = aux.args.speller
# paradigm_type = 'question'
params = aux.load_config()


sp = colorSpeller.ColorSpeller(pyttsx_rate = params.speller.pyttsx_rate, params=params)


finish = False
cnt = 0

# answers = [0,0,1,1,1,0,1,1,0,1,1,0,1,0,1]
# answers = [1,1,1,0,1,0,1,1,0,1,1,0,1,0,1]   # go until U and suggest UND
# answers = [1,0,1,1,1,1,1,1,1,0,1,1]           # back to the colors after green group
# answers = [1,1,1,1,0,1,1,1,1,1,0,1,0,0,1,1]           # back to the colors after green group
answers = [0, 0, 0, 1, 0]

while not finish:

    parent_conn.send([sp.current_selection, sp.current_string, sp.get_vocabulary()])
    current_selection = sp.current_selection
    t1 = time.time()
    stim = sp.present_stimulus(audio=params.speller.audio)
    t2 = time.time()

    # answer = answers[cnt]
    user_answer = input(stim + '? ')
    if user_answer is 'y':
        answer = aux.decision.yes
    elif user_answer is 'q':
        break
    else:
        answer = aux.decision.no
            
    time.sleep(0.01)
    finish = sp.process_result(aux.decision(answer).value)
    log.warning(f'selection: {sp.current_selection}')
    log.warning(f'probable words: {sp.get_vocabulary()}')
    #input('press enter')
    # print(f'cnt: {cnt}, current selection: {current_selection}, decision: {params.decision(answer).name} , Current state:  {sp.get_current_state()[0]}, {sp.get_current_state()[1]}, current string: {sp.current_string}')

    cnt += 1

if hasattr(sp, 'current_string'):
    sp._say(sp.current_string.lower(), sp.trigger[0], sp.trigger[1])

# Close the paradigm
sp.close()
matrix.terminate()